<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.7.2.3 $
 * $Author: dia_bolo $
 * $Date: 2008/01/08 13:45:13 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminsuper')) {
    mxErrorScreen('Access Denied');
    die();
}

if (@file_exists('images/iupload')) {
    $udir = 'images/iupload';
} else if (@file_exists('media/images')){
    $udir = 'media/images';
} else {
    mxErrorScreen('upload directory "media/images/" is not available');
    die();
}
$max_view_width = 400;

$msg = '';

if (isset($_FILES['imgfile'])) {
    $msg = ImagesAdd();
} else

if (isset($_POST['deletePic']) && $_POST['imgview'] != 'None') {
    $msg = ImagesDel();
    if (empty($msg)) {
        return;
    } 
} 

$imagesdir = dir($udir);
$imageslist = array();
while ($func = $imagesdir->read()) {
    if (preg_match('#\.(gif|jpe?g|png)$#i', $func)) {
        $imageslist[] = $func;
    } 
} 
closedir($imagesdir->handle);
natsort($imageslist);

if (isset($_POST['imgview']) && file_exists($udir . '/' . $_POST['imgview'])) {
    $imgview = $_POST['imgview'];
    $temp_image = $udir . '/' . $_POST['imgview'];
    $viewpath = $udir . '/' . $_POST['imgview'];
} else {
    $imgview = '';
    $temp_image = 'images/pixel.gif';
    $viewpath = ' ' . _FILEURL . '...';
} 

$options[] = '<option value="None"' . ((empty($imgview)) ? ' selected="selected"' : '') . '>- ' . _NONEIM . '</option>';
foreach ($imageslist as $image) {
    $options[] = '<option value="' . $image . '"' . (($imgview == $image) ? ' selected="selected"' : '') . '>' . $image . '</option>';
} 

for ($i = 0; $i <= 4; $i++) {
    $fields[] = '<input name="imgfile[' . $i . ']" type="file" size="50">';
} 

include ("header.php");
GraphicAdmin();
echo '<a name="imgtopp" id="imgtopp"></a>';
title(_MANAGEIM);
if ($msg) {
    OpenTable();
    echo $msg;
    CloseTable();
    echo "<br>";
} 
OpenTable();

?>
<fieldset><legend><?php echo _ADDNEWIM ?></legend>
<form enctype="multipart/form-data" method="post" action="admin.php?op=Images#imgtopp">
<input name="MAX_FILE_SIZE" value="10000000" type="hidden">
<?php echo implode("<br>\n", $fields) ?><br>
<input value="<?php echo _ADD ?>" class="formbutton" type="submit">
</form>
</fieldset>
<?php
CloseTable();
echo "<br>";
OpenTable();

?>
<fieldset><legend><?php echo _SELECTIM ?></legend>
<p class="content"><?php echo _THEREARE ?> <b><?php echo count($imageslist) ?></b> <?php echo _AVAILABLE ?></p>
<form method="post" action="admin.php?op=Images#imgtopp" name="imgform">
<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr align="center" valign="top">
<td>
    <select name="imgview" id="imgview" size="18" onChange="showimage()">
    <?php echo implode("\n", $options) ?>
    </select>
    <script language="JavaScript" type="text/javascript">
    <!--
    	document.write("<!-- ");
    //-->
    </script>
    <br><input type="submit" name="viewPic" value="<?php echo _VIEWIM ?>" onClick="showimage(); return false;">
    <script language="JavaScript" type="text/javascript">
    <!--
    	document.write(" --" + ">");
    //-->
    </script>
    <br><br><br><br>
    <input type="hidden" name="deleteOK" value="<?php echo _NO ?>">
    <input type="submit" name="deletePic" value="<?php echo _DELETE ?>" onClick="return confirmdelete();">
</td>
<td>
    <input type="text" name="idimagepath" value="<?php echo $viewpath ?>" size="60" style="width: <?php echo $max_view_width ?>px; padding-left: 0.7em;">
    <br>
    <div style="background-color: <?php echo $bgcolor2 ?>; width: <?php echo $max_view_width ?>px; height: 30em; overflow: auto; border: 1px solid <?php echo $bgcolor1 ?>;">
    <img src="<?php echo $temp_image ?>" alt="" name="theimage" id="theimage" border="0">
    </div>
</td>
</tr></table>
</form>
</fieldset>
<script language="JavaScript" type="text/javascript">
	<!--
	function showimage() {
		if (!document.images){
			return;
		}
		var xi = document.imgform.imgview.selectedIndex;
		var ximg = document.imgform.imgview.options[xi].value;
		if (xi == -1 || ximg == 'None') {
			document.images.theimage.src='images/pixel.gif';
            document.imgform.idimagepath.value = " <?php echo _FILEURL ?>...";
		} else {
			document.images.theimage.src='<?php echo $udir ?>/' + ximg;
            document.imgform.idimagepath.value='<?php echo $udir ?>/' + ximg;
		}
	}
	function confirmdelete() {
		var xi = document.imgform.imgview.selectedIndex;
		var ximg = document.imgform.imgview.options[xi].value;
		if (xi == -1 || ximg == 'None') {
			return false;
		}
		var delcheck = confirm("<?php echo mxHtmlEntityDecode(_ARESUREIM) ?>");
		if (delcheck) {
			document.imgform.deleteOK.value = "<?php echo _YES ?>";
		}
		return delcheck;
	}
	//-->
</script>
<?php
CloseTable();
include ("footer.php");

function ImagesAdd()
{
    global $udir, $max_view_width; 
    $basedir = dirname(dirname(dirname(__file__))); 
    $updir = $basedir . '/' . $udir . '/';
    foreach($_FILES['imgfile']['name'] as $i => $thisfile) {
        if (empty($thisfile)) {
            continue;
        } 
        // falls noch andere Punkte als fuer die Dateiendung vorhanden, 
        // diese durch _ ersetzen (Apache Bug)
        if (preg_match('#(.*\..*)(\..+)$#', $thisfile, $matches)) {
            $thisfile = str_replace('.', '_', $matches[1]) . $matches[2];
        }
        
        // falls Dateiname bereits vorhanden, eine Zahl als Zaehler dranhaengen:
        $xx = 1;
        while (file_exists($updir . $thisfile)) {
            $thisfile = preg_replace('#(.*)(?:_[0-9]+)*(\.[a-zA-Z]+)$#U', '\1_' . $xx . '\2', $thisfile);
            $xx++;
        } 
        
        if (isset($_FILES['imgfile']['error']) && $_FILES['imgfile']['error'][$i] > 0) {
            $message[] = '<em>' . $thisfile . '</em> error-code:' . $_FILES['imgfile']['error'][$i];
            continue;
            /* 
			UPLOAD_ERR_OK
			    Wert: 0; Es liegt kein Fehler vor, die Datei wurde erfolgreich hochgeladen. 
			
			UPLOAD_ERR_INI_SIZE
			    Wert: 1; Die hochgeladene Datei berschreitet die in der Anweisung upload_max_filesize in php.ini festgelegte Gre. 
			
			UPLOAD_ERR_FORM_SIZE
			    Wert: 2; Die hochgeladene Datei berschreitet die in dem HTML Formular mittels der Anweisung MAX_FILE_SIZE angegebene maximale Dateigre. 
			
			UPLOAD_ERR_PARTIAL
			    Wert: 3; Die Datei wurde nur teilweise hochgeladen. 
			
			UPLOAD_ERR_NO_FILE
			    Wert: 4; Es wurde keine Datei hochgeladen. 
			 */
        } 
        $size = @getimagesize($_FILES['imgfile']['tmp_name'][$i]);
        if ($size[2] < 1 || $size[2] > 3) {
            continue;
        } 
        $copyto = $updir . $thisfile;
        if (move_uploaded_file($_FILES['imgfile']['tmp_name'][$i], $copyto)) {
            $dimensions = ($size[0] > $max_view_width) ? ' width="' . $max_view_width . '"' : $size[3] ;
            $message[] = '<em>' . $thisfile . '</em> ' . _SUCCESFULLIM . '<br><img src="' . $udir . '/' . $thisfile . '" ' . $dimensions . ' vspace="10">'; 
            // zum vorselektieren ;-))
            $_POST['imgview'] = $thisfile;
        } else {
            $message[] = ' ' . _PROBSIM . ' <em>' . $thisfile . '</em> ' . _TOIM . ' <em>' . $copyto . '</em>';
        } 
    } 
    if (isset($message)) {
        return '<ul><li>' . implode('</li><li>', $message) . '</li></ul>';
    } 
    return '';
} 

function ImagesDel()
{
    global $udir, $max_view_width;
    if ($_POST['imgview'] == 'None' || !file_exists($udir . '/' . $_POST['imgview'])) {
        return '';
    } 

    $size = @getimagesize($udir . '/' . $_POST['imgview']);
    $img = ($size[0] > $max_view_width) ? ' width="' . $max_view_width . '"' : $size[3] ;
    $img = '<img src="' . $udir . '/' . $_POST['imgview'] . '" ' . $img . '>';

    if (isset($_POST['deleteOK']) && $_POST['deleteOK'] == _YES) {
        if (unlink($udir . '/' . $_POST['imgview'])) {
            $message = '<em>' . $_POST['imgview'] . '</em> ' . _SELECTDELETEIM;
        } else {
            $message = '<strong><em>' . $_POST['imgview'] . '</em> ' . _DELETEFAILDIM2 . '</strong><br><br>' . $img;
        } 
        return '<ul><li>' . $message . '</li></ul>';
    } else {
        include ("header.php"); 
        // GraphicAdmin();
        echo '<a name="imgtopp" id="imgtopp"></a>';
        title(_DELETEC);
        OpenTable();

        ?>
	<div align="center">
		<p><b><?php echo _ARESUREIM ?> <em><?php echo $_POST['imgview'] ?></em>?</b></p>
		<form method="post" action="admin.php?op=Images#imgtopp" name="imgform">
			<input type="submit" name="deletePic" value="<?php echo _YES ?>">
			<input type="submit" value="<?php echo _NO ?>">
			<input type="hidden" name="deleteOK" value="<?php echo _YES ?>">
			<input type="hidden" name="imgview" value="<?php echo htmlentities($_POST['imgview']) ?>">
		</form>
		<br><br>
		<?php echo $img ?>
		<br>
	</div>
<?php
        CloseTable();
        include ("footer.php");
    } 
    return '';
} 

?>